Name:           rasqal
Version:        0.9.22
Release:        1
Summary:        RDF Query Library
Group:          System Environment/Libraries
License:        LGPLv2+ or ASL 2.0
URL:            http://librdf.org/rasqal/
Source0:        http://download.librdf.org/source/%{name}-%{version}.tar.gz
Source1:        http://download.librdf.org/source/%{name}-%{version}.tar.gz.asc
BuildRoot:      %{_tmppath}/%{name}-%{version}-%{release}-root

BuildRequires:  libxml2-devel >= 2.6.32-2
BuildRequires:  mpfr-devel >= 2.4.2
BuildRequires:  pcre-devel >= 7.9-2
BuildRequires:  raptor2-devel >= 1.9.1

Requires:       libxml2 >= 2.6.32-2
Requires:       mpfr >= 2.4.2
Requires:       pcre >= 7.9-2
Requires:       raptor2 >= 2.0.0

%define _libdir64 %{_prefix}/lib64

%description
Rasqal is a library providing full support for querying Resource
Description Framework (RDF) including parsing query syntaxes, constructing
the queries, executing them and returning result formats.  It currently
handles the RDF Data Query Language (RDQL) and SPARQL Query language.

The library is available as 32-bit and 64-bit.


%package        devel
Summary:        Development files for the Rasqal RDF libraries
Group:          Development/Libraries
Requires:       %{name} = %{version}-%{release}
Requires:       pkg-config
Requires:       raptor2-devel >= 2.0.0

%description    devel
Libraries, includes etc to develop with the Rasqal RDF query language library.

If you are compiling a 32-bit program, no special compiler options are
needed.

If you are compiling a 64-bit program, you have to compile and link your
application with "cc -q64" or "gcc -maix64".


%prep
%setup -q
mkdir ../32bit
mv * ../32bit
mv ../32bit .
mkdir 64bit
cp -r 32bit/* 64bit/


%build
export CC="cc -qcpluscmt"

cd 64bit
# first build the 64-bit version
export OBJECT_MODE=64
export LDFLAGS="-L/opt/freeware/lib64 -L/opt/freeware/lib -Wl,-blibpath:/opt/freeware/lib64:/opt/freeware/lib:/usr/lib:/lib -Wl,-bmaxdata:0x80000000"
./configure \
    --prefix=%{_prefix} \
    --libdir=%{_libdir64} \
    --mandir=%{_mandir} \
    --enable-shared --disable-static \
    --enable-release \
    --with-raptor=system
make %{?_smp_mflags}

cd ../32bit
# now build the 32-bit version
export OBJECT_MODE=32
export LDFLAGS="-L/opt/freeware/lib -Wl,-blibpath:/opt/freeware/lib:/usr/lib:/lib -Wl,-bmaxdata:0x80000000"
./configure \
    --prefix=%{_prefix} \
    --mandir=%{_mandir} \
    --enable-shared --disable-static \
    --enable-release \
    --with-raptor=system
make %{?_smp_mflags}


%install
[ "${RPM_BUILD_ROOT}" != "/" ] && rm -rf ${RPM_BUILD_ROOT}

cd 64bit
export OBJECT_MODE=64
gmake DESTDIR=${RPM_BUILD_ROOT} install

(
  cd ${RPM_BUILD_ROOT}%{_bindir}
  for f in * ; do
    mv -f ${f} ${f}_64
  done
)

cd ../32bit
export OBJECT_MODE=32
gmake DESTDIR=${RPM_BUILD_ROOT} install

(
  cd ${RPM_BUILD_ROOT}%{_libdir64}
  for f in *.a ; do
    /usr/bin/ar -X64 -x ${f}
  done

  cd ${RPM_BUILD_ROOT}%{_libdir}
  for f in *.a ; do
    /usr/bin/ar -X32 -x ${f}
  done
)

# add the 64-bit shared objects to the shared libraries containing already the
# 32-bit shared objects
/usr/bin/ar -X64 -q ${RPM_BUILD_ROOT}%{_libdir}/lib%{name}.a ${RPM_BUILD_ROOT}%{_libdir64}/lib%{name}.so*

(
  cd ${RPM_BUILD_ROOT}
  for dir in bin include lib lib64
  do
    mkdir -p usr/${dir}
    cd usr/${dir}
    ln -sf ../..%{_prefix}/${dir}/* .
    cd -
  done
)


%clean
[ "${RPM_BUILD_ROOT}" != "/" ] && rm -rf ${RPM_BUILD_ROOT}


%files
%defattr(-,root,system,-)
%doc 32bit/AUTHORS 32bit/COPYING 32bit/COPYING.LIB 32bit/ChangeLog
%doc 32bit/LICENSE.txt 32bit/NEWS 32bit/README 32bit/LICENSE-2.0.txt
%doc 32bit/NOTICE 32bit/*.html
%{_bindir}/roqet*
%{_libdir}/*.a
%{_libdir}/*.so*
%{_libdir64}/*.so*
%{_mandir}/man1/roqet.1
/usr/bin/roqet*
/usr/lib/*.a
/usr/lib/*.so*
/usr/lib64/*.so*


%files devel
%defattr(-,root,system,-)
%doc 32bit/docs/README.html
%{_bindir}/rasqal-config*
%{_includedir}/rasqal/
%{_libdir}/*.la
%{_libdir64}/*.la
%{_libdir}/pkgconfig/rasqal.pc
%{_libdir64}/pkgconfig/rasqal.pc
%{_mandir}/man1/rasqal-config.1
%{_mandir}/man3/librasqal.3
%{_datadir}/gtk-doc/
/usr/bin/rasqal-config*
/usr/lib/*.la
/usr/lib64/*.la


%changelog
* Thu Jan 13 2011 Michael Perzl <michael@perzl.org> - 0.9.22-1
- updated to version 0.9.22

* Mon Dec 06 2010 Michael Perzl <michael@perzl.org> - 0.9.21-1
- updated to version 0.9.21

* Thu Dec 02 2010 Michael Perzl <michael@perzl.org> - 0.9.20-1
- first version for AIX V5.1 and higher
